<template>
  <mt-modal :ouvert.sync="ouvert" :size="size" @close="close">
    <section class="mt-modal-align-center">
      <p class="mt-modal-message" :class="classModifier">
        <slot></slot>
      </p>
      <slot name="buttons">
        <article class="field is-grouped is-grouped-centered">
          <p class="control">
            <b-button
              class="mt-button is-size-8 has-text-weight-semibold"
              type="is-secondary"
              native-type="button"
              @click="close"
            >
              {{ bAnnuler }}
            </b-button>
          </p>
          <slot name="action">
            <p class="control">
              <b-button
                class="mt-button is-size-8 has-text-weight-semibold"
                type="is-primary"
                native-type="button"
                @click="validerAction"
              >
                {{ actionButton }}
              </b-button>
            </p>
          </slot>
        </article>
      </slot>
      <slot name="footer"></slot>
    </section>
  </mt-modal>
</template>

<script>
import MtModal from '~/components/modal/mt-modal';

export default {
  name: 'MtModalAction',
  components: {
    MtModal,
  },
  props: {
    typeDelete: Boolean,
    messageExpanded: Boolean,
    ouvert: {
      type: Boolean,
      default: false,
      required: true,
    },
    bAnnuler: {
      type: String,
      default: 'annuler',
    },
    bAction: {
      type: String,
      default: null,
    },
    size: {
      type: [String, Number],
      default: 650,
    },
  },
  computed: {
    actionButton() {
      if (this.typeDelete && this.bAction == null) {
        return 'Supprimer';
      }
      if (this.bAction == null) {
        return 'Valider';
      }
      return this.bAction;
    },
    classModifier() {
      if (this.messageExpanded) {
        return 'align-self-strech';
      }
      return '';
    },
  },
  methods: {
    close() {
      this.$emit('update:ouvert', false);
    },
    validerAction() {
      this.$emit('action');
      this.close();
    },
  },
};
</script>

<style scoped lang="scss">
article.field.is-grouped {
  flex-wrap: wrap;

  /deep/ .control {
    margin-top: 0.25rem;
    margin-bottom: 0.25rem;
  }
}
</style>
